Index: TvEngine3/TVLibrary/SetupControls/FormTuningDetailCommon.cs
===================================================================
--- TvEngine3/TVLibrary/SetupControls/FormTuningDetailCommon.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupControls/FormTuningDetailCommon.cs	(working copy)
@@ -64,7 +64,7 @@
       int minorChannel = -1;
       int majorChannel = -1;
       string provider = "";
-      int channelType = 0;
+      ChannelProviderType channelType = ChannelProviderType.Analog;
       int band = 0;
       int satIndex = -1;
       var innerFecRate = (int)BinaryConvolutionCodeRate.RateNotSet;
Index: TvEngine3/TVLibrary/SetupTv/Dialogs/FormAnalogTuningDetail.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Dialogs/FormAnalogTuningDetail.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Dialogs/FormAnalogTuningDetail.cs	(working copy)
@@ -89,7 +89,7 @@
       TuningDetail.AudioSource = comboBoxAudioSource.SelectedIndex;
       TuningDetail.Frequency = (int)GetFrequency(textBoxAnalogFrequency.Text, "2");
       TuningDetail.IsVCRSignal = checkBoxVCR.Checked;
-      TuningDetail.ChannelType = 0;
+      TuningDetail.ChannelType = TvDatabase.ChannelProviderType.Analog;
     }
 
     private bool ValidateInput()
Index: TvEngine3/TVLibrary/SetupTv/Dialogs/FormATSCTuningDetail.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Dialogs/FormATSCTuningDetail.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Dialogs/FormATSCTuningDetail.cs	(working copy)
@@ -21,6 +21,7 @@
 using System;
 using System.Windows.Forms;
 using DirectShowLib.BDA;
+using TvDatabase;
 
 namespace SetupTv.Dialogs
 {
@@ -93,7 +94,7 @@
 
     private void UpdateTuningDetail()
     {
-      TuningDetail.ChannelType = 1;
+      TuningDetail.ChannelType = ChannelProviderType.ATSC;
       TuningDetail.ChannelNumber = Int32.Parse(textBoxProgram.Text);
       TuningDetail.Frequency = Int32.Parse(textBoxFrequency.Text);
       TuningDetail.MajorChannel = Int32.Parse(textBoxMajor.Text);
Index: TvEngine3/TVLibrary/SetupTv/Dialogs/FormDVBCTuningDetail.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Dialogs/FormDVBCTuningDetail.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Dialogs/FormDVBCTuningDetail.cs	(working copy)
@@ -21,6 +21,7 @@
 using System;
 using System.Windows.Forms;
 using DirectShowLib.BDA;
+using TvDatabase;
 
 namespace SetupTv.Dialogs
 {
@@ -128,7 +129,7 @@
       TuningDetail.Provider = textBoxDVBCProvider.Text;
       TuningDetail.FreeToAir = checkBoxDVBCfta.Checked;
       TuningDetail.Modulation = (int)(ModulationType)(comboBoxDvbCModulation.SelectedIndex - 1);
-      TuningDetail.ChannelType = 2;
+      TuningDetail.ChannelType = ChannelProviderType.DVBC;
     }
 
     private bool ValidateInput()
Index: TvEngine3/TVLibrary/SetupTv/Dialogs/FormDVBIPTuningDetail.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Dialogs/FormDVBIPTuningDetail.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Dialogs/FormDVBIPTuningDetail.cs	(working copy)
@@ -72,7 +72,7 @@
 
     private void UpdateTuningDetail()
     {
-      TuningDetail.ChannelType = 7;
+      TuningDetail.ChannelType = TvDatabase.ChannelProviderType.DVBIP;
       TuningDetail.ChannelNumber = Int32.Parse(textBoxDVBIPChannel.Text);
       TuningDetail.Url = textBoxDVBIPUrl.Text;
       TuningDetail.NetworkId = Int32.Parse(textBoxDVBIPNetworkId.Text);
Index: TvEngine3/TVLibrary/SetupTv/Dialogs/FormDVBSTuningDetail.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Dialogs/FormDVBSTuningDetail.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Dialogs/FormDVBSTuningDetail.cs	(working copy)
@@ -88,7 +88,7 @@
 
     private void UpdateTuningDetail()
     {
-      TuningDetail.ChannelType = 3;
+      TuningDetail.ChannelType = ChannelProviderType.DVBS;
       TuningDetail.Frequency = Int32.Parse(textBoxFrequency.Text);
       TuningDetail.NetworkId = Int32.Parse(textBoxNetworkId.Text);
       TuningDetail.TransportId = Int32.Parse(textBoxTransportId.Text);
Index: TvEngine3/TVLibrary/SetupTv/Dialogs/FormDVBTTuningDetail.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Dialogs/FormDVBTTuningDetail.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Dialogs/FormDVBTTuningDetail.cs	(working copy)
@@ -20,6 +20,7 @@
 
 using System;
 using System.Windows.Forms;
+using TvDatabase;
 
 namespace SetupTv.Dialogs
 {
@@ -74,7 +75,7 @@
 
     private void UpdateTuningDetail()
     {
-      TuningDetail.ChannelType = 4;
+      TuningDetail.ChannelType = ChannelProviderType.DVBT;
       TuningDetail.ChannelNumber = Int32.Parse(textBoxDVBTChannel.Text);
       TuningDetail.Frequency = Int32.Parse(textBoxDVBTfreq.Text);
       TuningDetail.NetworkId = Int32.Parse(textBoxNetworkId.Text);
Index: TvEngine3/TVLibrary/SetupTv/Dialogs/FormEditChannel.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Dialogs/FormEditChannel.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Dialogs/FormEditChannel.cs	(working copy)
@@ -137,7 +137,7 @@
           float frequency;
           switch (detail.ChannelType)
           {
-            case 0:
+            case ChannelProviderType.Analog:
               channelType = "Analog";
               if (detail.VideoSource == (int)AnalogChannel.VideoInputType.Tuner)
               {
@@ -150,35 +150,35 @@
                 description = detail.VideoSource.ToString();
               }
               break;
-            case 1:
+            case ChannelProviderType.ATSC:
               channelType = "ATSC";
               description = String.Format("{0} {1}:{2}", detail.ChannelNumber, detail.MajorChannel,
                                           detail.MinorChannel);
               break;
-            case 2:
+            case ChannelProviderType.DVBC:
               channelType = "DVB-C";
               frequency = detail.Frequency;
               frequency /= 1000.0f;
               description = String.Format("{0} MHz SR:{1}", frequency.ToString("f2"), detail.Symbolrate);
               break;
-            case 3:
+            case ChannelProviderType.DVBS:
               channelType = "DVB-S";
               frequency = detail.Frequency;
               frequency /= 1000.0f;
               description = String.Format("{0} MHz {1}", frequency.ToString("f2"),
                                           (((Polarisation)detail.Polarisation)));
               break;
-            case 4:
+            case ChannelProviderType.DVBT:
               channelType = "DVB-T";
               frequency = detail.Frequency;
               frequency /= 1000.0f;
               description = String.Format("{0} MHz BW:{1}", frequency.ToString("f2"), detail.Bandwidth);
               break;
-            case 5:
+            case ChannelProviderType.WebStream:
               channelType = "Web-Stream";
               description = detail.Url;
               break;
-            case 7:
+            case ChannelProviderType.DVBIP:
               channelType = "DVB-IP";
               description = detail.Url;
               break;
@@ -245,7 +245,7 @@
       {
         int index = mpListView1.SelectedIndices[0];
         TuningDetail tuningDetailToEdit = _tuningDetails[index];
-        FormTuningDetailCommon form = CreateDialog(tuningDetailToEdit.ChannelType);
+        FormTuningDetailCommon form = CreateDialog((int)tuningDetailToEdit.ChannelType);
         form.TuningDetail = tuningDetailToEdit;
         form.ShowDialog(this);
         UpdateTuningDetailList();
Index: TvEngine3/TVLibrary/SetupTv/Dialogs/FormWebStreamTuningDetail.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Dialogs/FormWebStreamTuningDetail.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Dialogs/FormWebStreamTuningDetail.cs	(working copy)
@@ -25,6 +25,7 @@
 using System.Drawing;
 using System.Text;
 using System.Windows.Forms;
+using TvDatabase;
 
 namespace SetupTv.Dialogs
 {
@@ -74,7 +75,7 @@
 
     private void UpdateTuningDetail()
     {
-      TuningDetail.ChannelType = 5;
+      TuningDetail.ChannelType = ChannelProviderType.WebStream;
       TuningDetail.Url = edStreamURL.Text;
       TuningDetail.Bitrate = (int)nudStreamBitrate.Value;
     }
Index: TvEngine3/TVLibrary/SetupTv/Sections/ChannelsInGroupControl.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/ChannelsInGroupControl.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/ChannelsInGroupControl.cs	(working copy)
@@ -27,6 +27,7 @@
 using TvLibrary.Interfaces;
 using MediaPortal.UserInterface.Controls;
 using TvLibrary.Log;
+using SetupTv.Sections.Helpers;
 
 namespace SetupTv.Sections
 {
@@ -69,25 +70,44 @@
 
         UpdateMenuAndTabs();
 
+        listView1.BeginUpdate();
         listView1.Items.Clear();
-        SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof (GroupMap));
 
-        sb.AddConstraint(Operator.Equals, "idGroup", _channelGroup.IdGroup);
-        sb.AddOrderByField(true, "sortOrder");
+        // read all channel maps for current group.
+        IList<GroupMap> maps = _channelGroup.ReferringGroupMap();
 
-        SqlStatement stmt = sb.GetStatement(true);
+        IDictionary<int, IList<TuningDetail>> dTuningDetails = ChannelListHelper.GetDictionaryOfTuningDetailsForGroup(_channelGroup.IdGroup, ChannelType.Tv);
+        IDictionary<int, Channel> dChannels = ChannelListHelper.GetDictionaryOfChannelsForGroup(_channelGroup.IdGroup, ChannelType.Tv);
 
-        IList<GroupMap> maps = ObjectFactory.GetCollection<GroupMap>(stmt.Execute());
-
+        // here we cannot just fill list with channels from channel list because of map.SortOrder
+        List<ListViewItem> items = new List<ListViewItem>();
+        IList<TuningDetail> tuningDetails;
+        Channel channel;
         foreach (GroupMap map in maps)
         {
-          Channel channel = map.ReferencedChannel();
-          if (!channel.IsTv)
-          {
-            continue;
-          }
-          listView1.Items.Add(CreateItemForChannel(channel, map));
+          if (dChannels.TryGetValue(map.IdChannel, out channel))
+            {
+              dTuningDetails.TryGetValue(channel.IdChannel, out tuningDetails);
+              int imageIndex = ChannelListIcons.GetChannelListIconIndex(channel, tuningDetails);
+              ListViewItem item = new ListViewItem(channel.DisplayName, imageIndex);
+              item.Checked = channel.VisibleInGuide;
+              item.Tag = map;
+
+              if ( (tuningDetails != null) && (tuningDetails.Count > 0))
+              {
+                item.SubItems.Add(tuningDetails[0].ChannelNumber.ToString());
+              }
+              items.Add(item);
+            }
         }
+        
+        // first remove our OnItemChecked event handler because we set item's check state when inserting item into items list,
+        // so no need to recheck it while filling the listview.
+        listView1.ItemChecked -= listView1_ItemChecked;
+        listView1.Items.AddRange(items.ToArray());
+        listView1.ItemChecked += listView1_ItemChecked;
+        listView1.EndUpdate();
+
         bool isAllChannelsGroup = (_channelGroup.GroupName == TvConstants.TvGroupNames.AllChannels);
         removeChannelFromGroup.Enabled = !isAllChannelsGroup;
         mpButtonDel.Enabled = !isAllChannelsGroup;
@@ -102,50 +122,6 @@
       }
     }
 
-    private ListViewItem CreateItemForChannel(Channel channel, object map)
-    {
-      bool hasFta = false;
-      bool hasScrambled = false;
-      IList<TuningDetail> tuningDetails = channel.ReferringTuningDetail();
-      foreach (TuningDetail detail in tuningDetails)
-      {
-        if (detail.FreeToAir)
-        {
-          hasFta = true;
-        }
-        if (!detail.FreeToAir)
-        {
-          hasScrambled = true;
-        }
-      }
-
-      int imageIndex;
-      if (hasFta && hasScrambled)
-      {
-        imageIndex = 5;
-      }
-      else if (hasScrambled)
-      {
-        imageIndex = 4;
-      }
-      else
-      {
-        imageIndex = 3;
-      }
-
-      ListViewItem item = new ListViewItem(channel.DisplayName, imageIndex);
-
-      item.Checked = channel.VisibleInGuide;
-      item.Tag = map;
-
-      IList<TuningDetail> details = channel.ReferringTuningDetail();
-      if (details.Count > 0)
-      {
-        item.SubItems.Add(details[0].ChannelNumber.ToString());
-      }
-      return item;
-    }
-
     private void listView1_ItemDrag(object sender, ItemDragEventArgs e)
     {
       if (e.Item is ListViewItem)
@@ -196,7 +172,7 @@
         layer.AddChannelToGroup(channel, _channelGroup);
 
         //get the new group map and set the listitem tag
-        SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof (GroupMap));
+        SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof(GroupMap));
 
         sb.AddConstraint(Operator.Equals, "idChannel", channel.IdChannel);
         sb.AddConstraint(Operator.Equals, "idGroup", _channelGroup.IdGroup);
Index: TvEngine3/TVLibrary/SetupTv/Sections/ChannelsInRadioGroupControl.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/ChannelsInRadioGroupControl.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/ChannelsInRadioGroupControl.cs	(working copy)
@@ -27,6 +27,7 @@
 using TvLibrary.Interfaces;
 using MediaPortal.UserInterface.Controls;
 using TvLibrary.Log;
+using SetupTv.Sections.Helpers;
 
 namespace SetupTv.Sections
 {
@@ -69,25 +70,44 @@
 
         UpdateMenuAndTabs();
 
+        listView1.BeginUpdate();
         listView1.Items.Clear();
-        SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof (RadioGroupMap));
 
-        sb.AddConstraint(Operator.Equals, "idGroup", _channelGroup.IdGroup);
-        sb.AddOrderByField(true, "sortOrder");
+        // read all channel maps for current group.
+        IList<RadioGroupMap> maps = _channelGroup.ReferringRadioGroupMap();
 
-        SqlStatement stmt = sb.GetStatement(true);
+        IDictionary<int, IList<TuningDetail>> dTuningDetails = ChannelListHelper.GetDictionaryOfTuningDetailsForGroup(_channelGroup.IdGroup, ChannelType.Radio);
+        IDictionary<int, Channel> dChannels = ChannelListHelper.GetDictionaryOfChannelsForGroup(_channelGroup.IdGroup, ChannelType.Radio);
 
-        IList<RadioGroupMap> maps = ObjectFactory.GetCollection<RadioGroupMap>(stmt.Execute());
-
+        // here we cannot just fill list with channels from channel list because of map.SortOrder
+        List<ListViewItem> items = new List<ListViewItem>();
+        IList<TuningDetail> tuningDetails;
+        Channel channel;
         foreach (RadioGroupMap map in maps)
         {
-          Channel channel = map.ReferencedChannel();
-          if (!channel.IsRadio)
-          {
-            continue;
+          if (dChannels.TryGetValue(map.IdChannel, out channel))
+            {
+              dTuningDetails.TryGetValue(channel.IdChannel, out tuningDetails);
+              int imageIndex = ChannelListIcons.GetChannelListIconIndex(channel, tuningDetails);
+              ListViewItem item = new ListViewItem(channel.DisplayName, imageIndex);
+              item.Checked = channel.VisibleInGuide;
+              item.Tag = map;
+
+              if ( (tuningDetails != null) && (tuningDetails.Count > 0))
+              {
+                item.SubItems.Add(tuningDetails[0].ChannelNumber.ToString());
+              }
+              items.Add(item);
           }
-          listView1.Items.Add(CreateItemForChannel(channel, map));
         }
+        
+        // first remove our OnItemChecked event handler because we set item's check state when inserting item into items list,
+        // so no need to recheck it while filling the listview.
+        listView1.ItemChecked -= listView1_ItemChecked;
+        listView1.Items.AddRange(items.ToArray());
+        listView1.ItemChecked += listView1_ItemChecked;
+        listView1.EndUpdate();
+
         bool isAllChannelsGroup = (_channelGroup.GroupName == TvConstants.RadioGroupNames.AllChannels);
         removeChannelFromGroup.Enabled = !isAllChannelsGroup;
         mpButtonDel.Enabled = !isAllChannelsGroup;
@@ -102,50 +122,6 @@
       }
     }
 
-    private ListViewItem CreateItemForChannel(Channel channel, object map)
-    {
-      bool hasFta = false;
-      bool hasScrambled = false;
-      IList<TuningDetail> tuningDetails = channel.ReferringTuningDetail();
-      foreach (TuningDetail detail in tuningDetails)
-      {
-        if (detail.FreeToAir)
-        {
-          hasFta = true;
-        }
-        if (!detail.FreeToAir)
-        {
-          hasScrambled = true;
-        }
-      }
-
-      int imageIndex;
-      if (hasFta && hasScrambled)
-      {
-        imageIndex = 2;
-      }
-      else if (hasScrambled)
-      {
-        imageIndex = 1;
-      }
-      else
-      {
-        imageIndex = 0;
-      }
-
-      ListViewItem item = new ListViewItem(channel.DisplayName, imageIndex);
-
-      item.Checked = channel.VisibleInGuide;
-      item.Tag = map;
-
-      IList<TuningDetail> details = channel.ReferringTuningDetail();
-      if (details.Count > 0)
-      {
-        item.SubItems.Add(details[0].ChannelNumber.ToString());
-      }
-      return item;
-    }
-
     private void listView1_ItemDrag(object sender, ItemDragEventArgs e)
     {
       if (e.Item is ListViewItem)
@@ -237,20 +213,16 @@
     {
       RadioChannelGroup group;
       ToolStripMenuItem menuItem = (ToolStripMenuItem)sender;
-
       if (menuItem.Tag == null)
       {
         GroupNameForm dlg = new GroupNameForm();
         dlg.IsRadio = true;
-
         if (dlg.ShowDialog(this) != DialogResult.OK)
         {
           return;
         }
-
         group = new RadioChannelGroup(dlg.GroupName, 9999);
         group.Persist();
-
         UpdateMenuAndTabs();
       }
       else
@@ -261,9 +233,7 @@
       ListView.SelectedIndexCollection indexes = listView1.SelectedIndices;
       if (indexes.Count == 0)
         return;
-
       TvBusinessLayer layer = new TvBusinessLayer();
-
       for (int i = 0; i < indexes.Count; ++i)
       {
         ListViewItem item = listView1.Items[indexes[i]];
@@ -291,10 +261,10 @@
         }
       }
 
-
       ListView.SelectedIndexCollection indexes = listView1.SelectedIndices;
       if (indexes.Count == 0)
         return;
+
       NotifyForm dlg = new NotifyForm("Deleting selected radio channels...",
                                       "This can take some time\n\nPlease be patient...");
       dlg.Show();
@@ -339,6 +309,31 @@
       ReOrder();
     }
 
+    private void listView1_MouseDoubleClick(object sender, MouseEventArgs e)
+    {
+      editChannelToolStripMenuItem_Click(null, null);
+    }
+
+    private void listView1_AfterLabelEdit(object sender, LabelEditEventArgs e)
+    {
+      if (e.Label != null)
+      {
+        Channel channel = ((RadioGroupMap)listView1.Items[e.Item].Tag).ReferencedChannel();
+        channel.DisplayName = e.Label;
+        channel.Persist();
+      }
+    }
+
+    private void listView1_ItemChecked(object sender, ItemCheckedEventArgs e)
+    {
+      Channel ch = ((RadioGroupMap)e.Item.Tag).ReferencedChannel();
+      if (ch.VisibleInGuide != e.Item.Checked)
+      {
+        ch.VisibleInGuide = e.Item.Checked;
+        ch.Persist();
+      }
+    }
+
     private void mpButtonPreview_Click(object sender, EventArgs e)
     {
       ListView.SelectedIndexCollection indexes = listView1.SelectedIndices;
@@ -515,26 +510,6 @@
       lvwColumnSorter.Order = SortOrder.None;
     }
 
-    private void listView1_AfterLabelEdit(object sender, LabelEditEventArgs e)
-    {
-      if (e.Label != null)
-      {
-        Channel channel = ((RadioGroupMap)listView1.Items[e.Item].Tag).ReferencedChannel();
-        channel.DisplayName = e.Label;
-        channel.Persist();
-      }
-    }
-
-    private void listView1_ItemChecked(object sender, ItemCheckedEventArgs e)
-    {
-      Channel ch = ((RadioGroupMap)e.Item.Tag).ReferencedChannel();
-      if (ch.VisibleInGuide != e.Item.Checked)
-      {
-        ch.VisibleInGuide = e.Item.Checked;
-        ch.Persist();
-      }
-    }
-
     private void mpButtonOrderByName_Click(object sender, EventArgs e)
     {
       this.listView1_ColumnClick(null, new ColumnClickEventArgs(0));
Index: TvEngine3/TVLibrary/SetupTv/Sections/Combinations.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/Combinations.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/Combinations.cs	(working copy)
@@ -22,12 +22,11 @@
 using System.Collections.Generic;
 using System.Windows.Forms;
 using TvControl;
-using Gentle.Framework;
 using TvDatabase;
 using TvLibrary.Interfaces;
 using similaritymetrics;
 using MediaPortal.UserInterface.Controls;
-using TvLibrary.Log;
+using SetupTv.Sections.Helpers;
 
 namespace SetupTv.Sections
 {
@@ -56,7 +55,7 @@
     private readonly MPListViewStringColumnSorter lvwColumnSorter2;
     private readonly MPListViewStringColumnSorter lvwColumnSorter3;
 
-    private Dictionary<int, CardType> cards;
+    private IDictionary<int, CardType> cards;
 
     public TvCombinations(string name)
       : base(name)
@@ -102,38 +101,35 @@
 
     private void mpComboBoxCard_SelectedIndexChanged(object sender, EventArgs e)
     {
+      Application.UseWaitCursor = true;
       mpListViewChannels.BeginUpdate();
       try
       {
         mpListViewChannels.Items.Clear();
         mpListViewMapped.Items.Clear();
 
-        SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof (Channel));
-        sb.AddOrderByField(true, "sortOrder");
-        CardInfo cardInfo = (CardInfo)mpComboBoxCard.SelectedItem;
+        Card card = ((CardInfo)mpComboBoxCard.SelectedItem).Card;
 
-        Card card = cardInfo.Card;
+        // get cardtype - dvb, analogue etc.
         CardType cardType = cards[card.IdCard];
-        IList<ChannelMap> maps = card.ReferringChannelMap();
 
+        TvBusinessLayer layer = new TvBusinessLayer();
+        bool enableDVBS2 = (layer.GetSetting("dvbs" + card.IdCard + "enabledvbs2", "false").Value == "true");
 
         List<ListViewItem> items = new List<ListViewItem>();
+
+        IDictionary<int, Channel> dChannels = ChannelListHelper.GetDictionaryOfChannelsForGroup(-1, ChannelType.Tv);
+        IDictionary<int, IList<TuningDetail>> dDetails = ChannelListHelper.GetDictionaryOfTuningDetailsForGroup(-1, ChannelType.Tv);
+        IList<ChannelMap> maps = card.ReferringChannelMap();
         foreach (ChannelMap map in maps)
         {
           Channel channel = null;
-          try
-          {
-            channel = map.ReferencedChannel();
-          }
-          catch (Exception) {}
-          if (channel == null)
+          if (!dChannels.TryGetValue(map.IdChannel, out channel))
             continue;
-          if (channel.IsTv == false)
-            continue;
-          TvBusinessLayer layer = new TvBusinessLayer();
-          bool enableDVBS2 = (layer.GetSetting("dvbs" + card.IdCard + "enabledvbs2", "false").Value == "true");
-          List<TuningDetail> tuningDetails = GetTuningDetailsByCardType(channel, cardType, enableDVBS2);
-          int imageIndex = GetImageIndex(tuningDetails);
+
+          List<TuningDetail> tuningDetails = ChannelListHelper.GetTuningDetailsByCardType(channel, dDetails, cardType, enableDVBS2);
+          
+          int imageIndex = ChannelListIcons.GetChannelListIconIndex(channel, tuningDetails);
           ListViewItem item = new ListViewItem(channel.DisplayName, imageIndex);
           item.Tag = channel;
           items.Add(item);
@@ -144,6 +140,7 @@
       finally
       {
         mpListViewChannels.EndUpdate();
+        Application.UseWaitCursor = false;
       }
     }
 
@@ -153,32 +150,35 @@
       try
       {
         mpListViewMapped.Items.Clear();
-        if (mpListViewChannels.SelectedIndices == null)
-          return;
         if (mpListViewChannels.SelectedIndices.Count != 1)
           return;
         Card card = ((CardInfo)mpComboBoxCard.SelectedItem).Card;
         ListViewItem selectedItem = mpListViewChannels.Items[mpListViewChannels.SelectedIndices[0]];
         Channel selectedChannel = (Channel)selectedItem.Tag;
-        IList<Channel> allChannels = Channel.ListAll();
+
+        IList<Channel> allChannels = ChannelListHelper.GetChannelsOfTypeForGroup(-1, ChannelType.Tv);
+        IDictionary<int, IList<TuningDetail>> dDetails = ChannelListHelper.GetDictionaryOfTuningDetailsForGroup(-1, ChannelType.Tv);
+        IDictionary<int, IList<ChannelMap>> dMaps = ChannelListHelper.GetDictionaryOfChannelMaps(ChannelType.Tv);
+
         List<ListViewItem> items = new List<ListViewItem>();
-        NotifyForm dlg = new NotifyForm("Searching for Similar Channels...",
-                                        "This can take some time\n\nPlease be patient...");
+        NotifyForm dlg = new NotifyForm("Searching for similar channels...",
+                                        "This can take some time.\n\nPlease be patient...");
         dlg.Show(this);
         dlg.WaitForDisplay();
         foreach (Channel channel in allChannels)
         {
-          if (channel.IsTv == false)
-            continue;
-
           bool isMapped = false;
-          IList<ChannelMap> list = channel.ReferringChannelMap();
-          foreach (ChannelMap map in list)
+          IList<ChannelMap> maps;
+          dMaps.TryGetValue(channel.IdChannel, out maps);
+          if (maps != null)
           {
-            if (map.IdCard == card.IdCard)
+            foreach (ChannelMap map in maps)
             {
-              isMapped = true;
-              break;
+              if (map.IdCard == card.IdCard)
+              {
+                isMapped = true;
+                break;
+              }
             }
           }
           if (isMapped)
@@ -187,8 +187,9 @@
           Levenstein comparer = new Levenstein();
           float result = comparer.getSimilarity(selectedChannel.DisplayName, channel.DisplayName);
 
-          IList<TuningDetail> details = channel.ReferringTuningDetail();
-          int imageIndex = GetImageIndex(details);
+          IList<TuningDetail> details;
+          dDetails.TryGetValue(channel.IdChannel, out details);
+          int imageIndex = ChannelListIcons.GetChannelListIconIndex(channel, details);
           ListViewItem item = new ListViewItem((result * 100f).ToString("f2") + "%", imageIndex);
           item.Tag = channel;
           item.SubItems.Add(channel.DisplayName);
@@ -332,90 +333,5 @@
       // Perform the sort with these new sort options.
       mpListViewMapped.Sort();
     }
-
-    private static List<TuningDetail> GetTuningDetailsByCardType(Channel channel, CardType cardType, bool enableDVBS2)
-    {
-      List<TuningDetail> result = new List<TuningDetail>();
-      foreach (TuningDetail tDetail in channel.ReferringTuningDetail())
-      {
-        switch (cardType)
-        {
-          case CardType.Analog:
-            if (tDetail.ChannelType == 0)
-              result.Add(tDetail);
-            break;
-          case CardType.Atsc:
-            if (tDetail.ChannelType == 1)
-              result.Add(tDetail);
-            break;
-          case CardType.DvbC:
-            if (tDetail.ChannelType == 2)
-              result.Add(tDetail);
-            break;
-          case CardType.DvbS:
-            if (tDetail.ChannelType == 3)
-            {
-              if (!enableDVBS2 && (tDetail.Pilot > -1 || tDetail.RollOff > -1))
-              {
-                Log.Debug(String.Format(
-                  "Imported channel {0} detected as DVB-S2. Skipped! \n Enable \"DVB-S2 tuning\" option in your TV-Card properties to be able to combine these channels.",
-                  tDetail.Name));
-              }
-              else
-              {
-                result.Add(tDetail);
-              }
-            }
-            break;
-          case CardType.DvbT:
-            if (tDetail.ChannelType == 4)
-              result.Add(tDetail);
-            break;
-          case CardType.DvbIP:
-            if (tDetail.ChannelType == 7)
-              result.Add(tDetail);
-            break;
-          case CardType.RadioWebStream:
-            if (tDetail.ChannelType == 5)
-              result.Add(tDetail);
-            break;
-          default:
-            break;
-        }
-      }
-      return result;
-    }
-
-    private static int GetImageIndex(IList<TuningDetail> tuningDetails)
-    {
-      bool hasFta = false;
-      bool hasScrambled = false;
-      foreach (TuningDetail detail in tuningDetails)
-      {
-        if (detail.FreeToAir)
-        {
-          hasFta = true;
-        }
-        if (!detail.FreeToAir)
-        {
-          hasScrambled = true;
-        }
-      }
-
-      int imageIndex;
-      if (hasFta && hasScrambled)
-      {
-        imageIndex = 5;
-      }
-      else if (hasScrambled)
-      {
-        imageIndex = 4;
-      }
-      else
-      {
-        imageIndex = 3;
-      }
-      return imageIndex;
-    }
   }
 }
\ No newline at end of file
Index: TvEngine3/TVLibrary/SetupTv/Sections/Epg.Designer.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/Epg.Designer.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/Epg.Designer.cs	(working copy)
@@ -326,8 +326,13 @@
             0,
             0,
             0});
+      this.numericUpDownTSEpgTimeout.Minimum = new decimal(new int[] {
+            1,
+            0,
+            0,
+            0});
       this.numericUpDownTSEpgTimeout.Name = "numericUpDownTSEpgTimeout";
-      this.numericUpDownTSEpgTimeout.Size = new System.Drawing.Size(86, 20);
+      this.numericUpDownTSEpgTimeout.Size = new System.Drawing.Size(73, 20);
       this.numericUpDownTSEpgTimeout.TabIndex = 10;
       this.numericUpDownTSEpgTimeout.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
       this.numericUpDownTSEpgTimeout.Value = new decimal(new int[] {
@@ -351,11 +356,11 @@
       // 
       this.label22.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
       this.label22.AutoSize = true;
-      this.label22.Location = new System.Drawing.Point(173, 42);
+      this.label22.Location = new System.Drawing.Point(149, 44);
       this.label22.Name = "label22";
-      this.label22.Size = new System.Drawing.Size(28, 13);
+      this.label22.Size = new System.Drawing.Size(47, 13);
       this.label22.TabIndex = 7;
-      this.label22.Text = "mins";
+      this.label22.Text = "seconds";
       // 
       // label23
       // 
@@ -401,7 +406,7 @@
       this.checkboxSameTransponder.Name = "checkboxSameTransponder";
       this.checkboxSameTransponder.Size = new System.Drawing.Size(257, 17);
       this.checkboxSameTransponder.TabIndex = 14;
-      this.checkboxSameTransponder.Text = "Grap EPG only for channels on same transponder";
+      this.checkboxSameTransponder.Text = "Grab EPG only for channels on same transponder";
       this.checkboxSameTransponder.UseVisualStyleBackColor = true;
       // 
       // label1
